unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OmegaTimer, OmegaFont, OmegaInput, OmegaImageList, OmegaScreen,
  OmegaSprite;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaInput1: TOmegaInput;
    OmegaFont1: TOmegaFont;
    OmegaTimer1: TOmegaTimer;
    OmegaSprite1: TOmegaSprite;
    OmegaImageList1: TOmegaImageList;
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    procedure TworzZolnierzy(const plik:string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses OmegaZolnierz;
{$R *.DFM}
procedure TForm1.TworzZolnierzy(const plik:string);
  function CzytajModel(s:string):tabModel;
  var
   ss:string;
   k,i:byte;
  begin
   //zaaduj biezcy model postaci
   i:=0;
   k:=0;
   while i<=length(s) do
   begin
    //czy spacja lub koniec ciagu znakow
    if (s[i]=' ')or(i=length(s))
    then begin
      result[k]:=StrToInt(TrimRight(ss));ss:='';
      inc(k);
    end;
    inc(i);
    ss:=ss+s[i];
   end;//koniec while
  end;//Koniec funkcji
const
  kierunek:array [0..15] of byte=(0,3,6,9,0,3,6,9,0,3,6,9,0,3,6,9);
var
  Lista:TStringList;
  i:integer;
  tablica:tabModel;
begin
  Randomize;
  Lista:=TStringList.Create;
  lista.LoadFromFile(ExtractFilePath(ParamStr(0))+plik);
  for i:=0 to Lista.Count-1 do begin
   tablica:=CzytajModel(Lista[i]);
   with TZolnierz.Create(OmegaSprite1,OmegaImageList1) do begin
        //ustaw indeksy zasobw obrazu grafiki.
        //Uwaga: ta czynnosc tez powinna byc pobierana z danych modelu
        //tu dla uproszczenia ustawiam te parametry rcznie
        IdObrazKorpus :=0;
        IdObrazGlowa  :=1;
        IdObrazBron   :=2;
        IdObrazTarcza :=3;
        //wczytaj klatki obrazu korpusu,gowy itd
        IdKlatkaKorpus:=tablica[0];
        IdKlatkaGlowa :=tablica[1];
        IdKlatkaBron  :=tablica[2];
        IdKlatkaTarcza:=tablica[3];
        //losuj wsprzedne pozycji
        x:=Random(OmegaScreen1.Width-100);
        y:=Random(OmegaScreen1.Height-100);
        //losuj kierunek ruchu
        OffSetKierunku:=kierunek[Random(15)];
   end;
  end;
  Lista.Free;
end;
procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin
 OmegaInput1.Update;
 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
  OmegaScreen1.ToggleFullScreen;
 if not omegascreen1.CanDraw then exit;
 OmegaScreen1.ClearScreen(0,0,0,0);
 OmegaScreen1.BeginRender;
 OmegaSprite1.Collision;
 OmegaSprite1.Dead;
 OmegaSprite1.Move(OmegaTimer1.DeltaSecs);
 OmegaSprite1.Draw;
 OmegaFont1.Print(0,0,'FPS: '+IntToStr(OmegaTimer1.FPS));
 OmegaScreen1.EndRender;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i:byte;
begin
  OmegaScreen1.Init;
  OmegaScreen1.SetHWnd(self.handle);
  OmegaFont1.Init;
  OmegaFont1.CreateFont('Arial',10,[]);
  OmegaFont1.Color:=OmegaColor(0,200,0);
  TworzZolnierzy('postacie001.txt');
  //utworz 3 punkty werbunkowe- sztandary
  for i:=0 to 2 do
  with TSztandar.Create(OmegaSprite1,OmegaImageList1,4)do begin
       x:=Random(OmegaScreen1.width-100);
       y:=Random(OmegaScreen1.height-100);
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OmegaTimer1.Enabled:=false;
  OmegaSprite1.Dead;
  OmegaScreen1.FreeOnRelease;
  //if OmegaScreen1.FullScreen then  OmegaScreen1.ToggleFullScreen;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 OmegaTimer1.Enabled:=true;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#27 then close;
end;

end.
